"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _types = require("../../constants/types");
var _defaults = require("../../config/defaults");
var _imageUtils = require("../../utils/imageUtils");
var _useIntersectionObserver = require("../../hooks/useIntersectionObserver");
var _Placeholder = _interopRequireDefault(require("../Placeholder/Placeholder"));
var _excluded = ["src", "alt", "className", "style", "onLoad", "onError", "offset", "useIntersectionObserver", "optimize", "breakpoints", "imageWidths", "sizes", "quality", "placeholderType", "placeholderImage", "customPlaceholder", "effectType", "effectAmount", "backgroundColor"];
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var s = Object.getOwnPropertySymbols(e); for (r = 0; r < s.length; r++) o = s[r], t.includes(o) || {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (e.includes(n)) continue; t[n] = r[n]; } return t; }
var LazyLoadImage = function LazyLoadImage(_ref) {
  var src = _ref.src,
    alt = _ref.alt,
    className = _ref.className,
    style = _ref.style,
    onLoad = _ref.onLoad,
    onError = _ref.onError,
    offset = _ref.offset,
    enableIntersectionObserver = _ref.useIntersectionObserver,
    optimize = _ref.optimize,
    breakpoints = _ref.breakpoints,
    imageWidths = _ref.imageWidths,
    sizes = _ref.sizes,
    quality = _ref.quality,
    placeholderType = _ref.placeholderType,
    placeholderImage = _ref.placeholderImage,
    customPlaceholder = _ref.customPlaceholder,
    effectType = _ref.effectType,
    effectAmount = _ref.effectAmount,
    backgroundColor = _ref.backgroundColor,
    props = _objectWithoutProperties(_ref, _excluded);
  var _useState = (0, _react.useState)(false),
    _useState2 = _slicedToArray(_useState, 2),
    isLoaded = _useState2[0],
    setIsLoaded = _useState2[1];
  var imageRef = (0, _react.useRef)(null);
  var mergedBreakpoints = (0, _react.useMemo)(function () {
    return _objectSpread(_objectSpread({}, _defaults.defaultBreakpoints), breakpoints);
  }, [breakpoints]);
  var mergedWidths = (0, _react.useMemo)(function () {
    return _objectSpread(_objectSpread({}, _defaults.defaultImageWidths), imageWidths);
  }, [imageWidths]);
  var isInView = (0, _useIntersectionObserver.useIntersectionObserver)(imageRef, {
    enabled: enableIntersectionObserver,
    offset: offset
  });
  var srcSet = (0, _react.useMemo)(function () {
    return optimize ? (0, _imageUtils.generateSrcSet)(src, mergedWidths, quality) : '';
  }, [src, optimize, mergedWidths, quality]);
  var sizeAttribute = (0, _react.useMemo)(function () {
    return (0, _imageUtils.generateSizes)(mergedBreakpoints, sizes);
  }, [mergedBreakpoints, sizes]);
  var handleImageLoad = function handleImageLoad(e) {
    setIsLoaded(true);
    onLoad === null || onLoad === void 0 || onLoad(e);
  };
  var handleImageError = function handleImageError(e) {
    console.error('Image failed to load:', e);
    onError === null || onError === void 0 || onError(e);
  };
  return /*#__PURE__*/_react["default"].createElement("div", _extends({
    ref: imageRef,
    className: className,
    style: _objectSpread(_objectSpread({}, style), {}, {
      position: 'relative',
      overflow: 'hidden'
    })
  }, props), /*#__PURE__*/_react["default"].createElement(_Placeholder["default"], {
    type: placeholderType,
    isLoaded: isLoaded,
    placeholderImage: placeholderImage,
    customPlaceholder: customPlaceholder,
    effectType: effectType,
    effectAmount: effectAmount,
    backgroundColor: backgroundColor
  }), isInView && /*#__PURE__*/_react["default"].createElement("img", {
    src: optimize ? "".concat(src, "?w=").concat(mergedWidths.md[0], "&q=").concat(quality) : src,
    srcSet: srcSet,
    sizes: sizeAttribute,
    alt: alt,
    onLoad: handleImageLoad,
    onError: handleImageError,
    style: {
      width: '100%',
      height: '100%',
      objectFit: 'cover',
      opacity: isLoaded ? 1 : 0,
      transition: 'opacity 0.3s ease-in-out'
    },
    loading: "lazy",
    decoding: "async"
  }));
};
LazyLoadImage.propTypes = {
  src: _propTypes["default"].string.isRequired,
  alt: _propTypes["default"].string,
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  onLoad: _propTypes["default"].func,
  onError: _propTypes["default"].func,
  offset: _propTypes["default"].number,
  useIntersectionObserver: _propTypes["default"].bool,
  optimize: _propTypes["default"].bool,
  breakpoints: _propTypes["default"].object,
  imageWidths: _propTypes["default"].object,
  sizes: _propTypes["default"].string,
  quality: _propTypes["default"].number,
  placeholderType: _propTypes["default"].oneOf(Object.values(_types.PlaceholderTypes)),
  placeholderImage: _propTypes["default"].string,
  customPlaceholder: _propTypes["default"].element,
  effectType: _propTypes["default"].oneOf(Object.values(_types.EffectTypes)),
  effectAmount: _propTypes["default"].number,
  backgroundColor: _propTypes["default"].string
};
LazyLoadImage.defaultProps = {
  alt: '',
  className: '',
  style: {},
  onLoad: function onLoad() {},
  onError: function onError() {},
  offset: 0,
  useIntersectionObserver: true,
  optimize: false,
  quality: 80,
  placeholderType: _types.PlaceholderTypes.NONE,
  effectType: _types.EffectTypes.BLUR,
  effectAmount: 10
};
var _default = exports["default"] = LazyLoadImage;