"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _types = require("../../constants/types");
var _styles = require("./styles");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var Placeholder = function Placeholder(_ref) {
  var type = _ref.type,
    isLoaded = _ref.isLoaded,
    placeholderImage = _ref.placeholderImage,
    customPlaceholder = _ref.customPlaceholder,
    effectType = _ref.effectType,
    effectAmount = _ref.effectAmount,
    backgroundColor = _ref.backgroundColor;
  if (isLoaded) return null;
  switch (type) {
    case _types.PlaceholderTypes.IMAGE:
      if (!placeholderImage) return null;
      return /*#__PURE__*/_react["default"].createElement("img", {
        src: placeholderImage,
        alt: "loading placeholder",
        style: _styles.baseStyles
      });
    case _types.PlaceholderTypes.CUSTOM:
      if (!customPlaceholder) return null;
      return /*#__PURE__*/_react["default"].createElement("div", {
        style: _styles.baseStyles
      }, customPlaceholder);
    case _types.PlaceholderTypes.EFFECT:
      return /*#__PURE__*/_react["default"].createElement("div", {
        style: _objectSpread(_objectSpread({}, _styles.baseStyles), (0, _styles.getEffectStyles)(effectType, effectAmount, backgroundColor))
      });
    default:
      return null;
  }
};
Placeholder.propTypes = {
  type: _propTypes["default"].oneOf(Object.values(_types.PlaceholderTypes)).isRequired,
  isLoaded: _propTypes["default"].bool.isRequired,
  placeholderImage: _propTypes["default"].string,
  customPlaceholder: _propTypes["default"].element,
  effectType: _propTypes["default"].oneOf(Object.values(_types.EffectTypes)),
  effectAmount: _propTypes["default"].number,
  backgroundColor: _propTypes["default"].string
};
var _default = exports["default"] = Placeholder;