"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getEffectStyles = exports.baseStyles = void 0;
var baseStyles = exports.baseStyles = {
  position: 'absolute',
  top: 0,
  left: 0,
  width: '100%',
  height: '100%',
  objectFit: 'cover'
};
var getEffectStyles = exports.getEffectStyles = function getEffectStyles(effectType, effectAmount, backgroundColor) {
  switch (effectType) {
    case EffectTypes.BLUR:
      return {
        filter: "blur(".concat(effectAmount, "px)"),
        transform: 'scale(1.1)'
      };
    case EffectTypes.OPACITY:
      return {
        opacity: effectAmount
      };
    case EffectTypes.COLOR:
      return {
        backgroundColor: backgroundColor || '#f0f0f0'
      };
    default:
      return {};
  }
};